<script>
	export let index = -1
	export let length = 0
	export let text = ''

	$: pre = text.substring(0, index)
	$: current = text.substring(index, index+length)
	$: post = text.substring(index+length)

	let highlighted //on current change, scroll into view
	$: current && highlighted.scrollIntoView({
		behaviour: 'smooth', block: 'center', inline: 'center'
	})
</script>
<style>
	pre{
		flex: 1 1 auto;
		display: flex;
		flex-flow: column;
		padding: 0.4em;
		align-items: center;
		white-space: pre-wrap;
	}
	span{
		background-color: var(--color0);
		color: var(--color3);
	}
	.highlighted{
		text-decoration: underline;
	}
</style>
<pre>
	<span>{pre}</span><span bind:this={highlighted} class='highlighted'>{current}</span><span>{post}</span>
</pre>
